<?php

# VERSION=8
# CHANGES=do not resolve host to redirect

include((file_exists("/usr/local/php/beroConf.php") ? "/usr/local/php/beroConf.php" : "/usr/fallback/beroConf.php"));

function get_app_master ($app_root) {

	if (!is_dir($app_root) || !($dh = opendir($app_root))) {
		return(NULL);
	}

	while (($app_name = readdir($dh)) !== false) {
		if (($app_name == ".") || ($app_name == "..")) {
			continue;
		}

		$app_version = $app_root . "/" . $app_name . "/VERSION";

		if (!($fp = fopen($app_version, "r"))) {
			continue;
		}

		$fcont = fread($fp, filesize($app_version));
		fclose($fp);

		if (strstr($fcont, "CLASS=master")) {
			closedir($dh);
			return($app_name);
		}

	}

	closedir($dh);

	return(NULL);
}

$userapp_root		= "/apps";
$userapp_master_dir	= get_app_master($userapp_root);
$userapp_master_www	= file_exists($userapp_root . "/" . $userapp_master_dir . "/www/index.php");

if (($root_db = new beroConf("root")) && ($root_db->get("root", "userapp-enabled") == 1) && $userapp_master_www) {
	header("Location:/userapp/" . $userapp_master_dir . "/index.php");
	exit();
} elseif (file_exists("/usr/local/www/index.php")) {
	header("Location:/app/index.php");
	exit();
}

?>
<xml version="1.0" encoding="UTF-8">
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
	<head>
		<title>bero*fix Recovery Utility</title>
	</head>
	<body>
		<h2>bero*fix Recovery Utility</title>
		<hr>
		<h3>Diagnostic:</h3>
		<ul>
			<li><a href="cgi-bin/info.sh">Info</a></li>
			<li><a href="cgi-bin/phpinfo.php">PHPinfo</a></li>
		</ul>
		<h3>Configuration:</h3>
		<ul>
			<li><a href="cgi-bin/confdb.php">Configuration database</a></li>
			<li><a href="cgi-bin/network-tool.php">Network tool</a></li>
		</ul>
		<h3>Firmware:</h3>
		<ul>
			<li><a href="cgi-bin/update-tool.php">Update tool</a></li>
		</ul>
		<h3>System:</h3>
		<ul>
			<li><a href="cgi-bin/reboot.php">Reboot</a></li>
		</ul>
	</body>
</html>
