<?php


/**
 * Klasse General
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */

class remoteManagement {

	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {
		// args
		$m = $_GET['m'];

		include('./includes/header.php');
		$remoteM_table = $this->dynamic_table();
		// build page content
		$ret .= "<br>" . $remoteM_table;

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}


	/*
	 * Der boolesche Wert von cloud_enable, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */
	function cloud_enable() {
		require_once( '/usr/local/php/beroConf.php' );
		$bc = new beroConf('root');
		$cloud_enable = $bc->get("root","cloud_enable");
		if($cloud_enable == "1")
			return "<input type='hidden' name='cloud_enable' value='0'>
					<input type='checkbox' name='cloud_enable' value='1' checked>";
		else
			return "<input type='hidden' name='cloud_enable' value='0'>
					<input type='checkbox' name='cloud_enable' value='1'>";

	}
	/*
	 * Der boolesche Wert von snmp-enabled, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */
	function snmp_enabled() {
		require_once( '/usr/local/php/beroConf.php' );
		$bc = new beroConf('root');
		$snmp_enable = $bc->get("root","snmp-enabled");
		if($snmp_enable == "1")
			return "<input type='hidden' name='snmp_enabled' value='0'>
					<input type='checkbox' id='snmp_enable' onchange='snmp_show();' name='snmp_enabled' value='1' checked>";
		else
			return "<input type='hidden' name='snmp_enabled' value='0'>
					<input type='checkbox' id='snmp_enable' onchange='snmp_show();' name='snmp_enabled' value='1'>";

	}
        /*
	 * Der Wert von snmptraps, der in der Datenbank gespeichert ist wird geholt
	 * und gesplittet, die erlaubte Werte werden als Checkbox angezeigt, bei den 
         * gespeicherten werden die Häckchen gesetzt.
	 */
	function snmptraps() {
		require_once( '/usr/local/php/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps = $bc->get("root","snmptraps");
                $snmptraps=explode (",",$snmptraps);
                //Wenn die Optionen mehr werden bitte auskommentieren
		//$res= "<fieldset>";
                if (in_array("snmptrap_isdnl2",$snmptraps)) $res.="<input type='checkbox' name='snmptraps' value='snmptrap_isdnl2' checked> ISDN-Layer 2";
                else $res.="<input type='checkbox' name='snmptraps' value='snmptrap_isdnl2'> ISDN-Layer 2";
                //$res.="</fieldset>";
		return $res;
	}
        
        /*
	 * Der Wert von snmptraps_sink, der in der Datenbank gespeichert ist wird geholt
	 * und der Wert in einem Textfeld angezeigt.
	 */
	function snmptraps_sink() {
		require_once( '/usr/local/php/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps_sink = $bc->get("root","snmptraps_sink");
		return "<input type='text' name='snmptraps_sink' value='".$snmptraps_sink."'> ";
                
	}
        
         /*
	 * Der Wert von snmptraps_intervall, der in der Datenbank gespeichert ist wird geholt
	 * und der Wert in einem Textfeld angezeigt.
	 */
	function snmptraps_intervall() {
		require_once( '/usr/local/php/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps_intervall = $bc->get("root","snmptraps_intervall");
		return "<input type='text' name='snmptraps_intervall' value='".$snmptraps_intervall."'> ";
                
	}
        
        /*
	 * Der boolesche Wert von proxyEnabled, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */
	function proxy_enable() {
		$ba=new beroAri();
		$proxy_enable = $ba->get("proxyEnabled");
		if($proxy_enable == "1")
			return "<input type='hidden' name='proxyEnabled' value='0'><input type='checkbox' name='proxyEnabled' value='1' checked>";
		else
			return "<input type='hidden' name='proxyEnabled' value='0'><input type='checkbox' name='proxyEnabled' value='1'>";

	}
	/*
	 * Die Cloud key, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Textfelds und nachher angezeigt.
	 */
	function cloud_key() {
		require_once( '/usr/local/php/beroConf.php' );
		$bc = new beroConf('root');
		return $bc->get("root","cloud_key");
	}
        
        /*
	 * Das Proxytyp, das in der Datenbank gespeichert ist, 
         * ein Selectbox wird zurückgegeben
	 */
	function proxy_type() {
		$ba=new beroAri();
                $proxyType=$ba->get("proxyType");
                $select="<select name='proxyType'>";
                ($proxyType=="CURLPROXY_HTTP") ? $select.="<option value='CURLPROXY_HTTP' selected>HTTP</option>" : $select.="<option value='CURLPROXY_HTTP'>HTTP</option>";
                ($proxyType=="CURLPROXY_SOCKS5") ? $select.="<option value='CURLPROXY_SOCKS5' selected>SOCKS5</option>" : $select.="<option value='CURLPROXY_SOCKS5'>SOCKS5</option>";
                $select.="</select>";
		return $select;
	}
        
        /*
     * Check, if a valid url is provided
     */

    function isDomainAvailable($url) {
        $connected = @fsockopen($url, 443); //website and port
        if ($connected) {
            $is_conn = true; //action when connected
            fclose($connected);
        } else {
            $is_conn = false; //action in connection failure
        }
        return $is_conn;
    }
    



	/*
	 * Funktion dynamic_table
	 */

	function dynamic_table() {
                $ba=new beroAri();
		require_once( '/usr/local/php/beroConf.php' );
		$result ="";
		//Wenn man Änderugen von der Daten macht werden die in der Tabelle der Datenbank
		//aktualisiert
		if (isset($_POST['cloud_enable'])) {

			$bc = new beroConf('root');
			$bc->set('root','cloud_enable',$_POST['cloud_enable']);
			if (isset($_POST['cloud_key'])) $bc->set('root','cloud_key',$_POST['cloud_key']);



			$query=$ba->select("select option from activate");
			while($entry = $ba->fetch_array($query)){

				if ($entry['option'] <= 1){
					$query =  $ba->update("UPDATE activate SET option=1");
					$table.= "<script>aktivieren(1,'remoteM','1','".ACTIVATE."');</script>";
				}
			}
		}
		if (isset($_POST['snmp_enabled'])) {
			$bc = new beroConf('root');
			$bc->set('root','snmp-enabled',$_POST['snmp_enabled']);
                        if($_POST['snmp_enabled']==1){
                            $bc->set('root','snmptraps',$_POST['snmptraps']);
                            $bc->set('root','snmptraps_sink',$_POST['snmptraps_sink']);
                            $bc->set('root','snmptraps_intervall',$_POST['snmptraps_intervall']);
                        }else{
                            $bc->set('root','snmptraps',"");
                            $bc->set('root','snmptraps_sink',"");
                            $bc->set('root','snmptraps_intervall',"");
                        }

			$query=$ba->select("select option from activate");
			while($entry = $ba->fetch_array($query)){

				if ($entry['option'] <= 1){
					$query =  $ba->update("UPDATE activate SET option=1");
					$table.= "<script>aktivieren(1,'remoteM','1','".ACTIVATE."');</script>";
				}
			}
		}
                if ($_POST['proxyEnabled']=='1' && isset($_POST['proxyAddress']) && isset($_POST['proxyPort']) && isset($_POST['proxyType'])){
                    $ba->set('proxyEnabled',$_POST['proxyEnabled']);
                    $ba->set('proxyAddress',$_POST['proxyAddress']);
                    $ba->set('proxyPort',$_POST['proxyPort']);
                    $ba->set('proxyType',$_POST['proxyType']);
                    $ba->set('proxyUser',$_POST['proxyUser']);
                    $ba->set('proxySecret',$_POST['proxySecret']);
                    $ba=new beroAri();
                    $query=$ba->select("select option from activate");
                    while($entry = $ba->fetch_array($query)){

			if ($entry['option'] <= 1){
                            $query =  $ba->update("UPDATE activate SET option=1");
                            $table.= "<script>aktivieren(1,'remoteM','1','".ACTIVATE."');</script>";
			}
                    }
                }else if ($_POST['proxyEnabled']=='0'){
                    $ba->set('proxyEnabled',0);
                    $ba->set('proxyAddress',"");
                    $ba->set('proxyPort',"");
                    $ba->set('proxyType',"");
                    $ba->set('proxyUser',"");
                    $ba->set('proxySecret',"");
                    $ba=new beroAri();
                    $query=$ba->select("select option from activate");
                    while($entry = $ba->fetch_array($query)){

			if ($entry['option'] <= 1){
                            $query =  $ba->update("UPDATE activate SET option=1");
                            $table.= "<script>aktivieren(1,'remoteM','1','".ACTIVATE."');</script>";
			}
                    }
                }
		if (isset($_POST['cloud_username']) && isset($_POST['cloud_password'])) {
                        $bc = new beroConf('root');
                        if ($bc->get('root','lan-nameserver')=="" || $bc->get('root','lan-gateway')=="") $result=CLOUD_NETWORK_HINT;
                        else if (!$this->isDomainAvailable($ba->get("cloudAddress"))) $result=CLOUD_NO_CONNECTION_HINT;
                        else{
                            $res=file_get_contents('/proc/cmdline');
                            preg_match("/[^a-zA-Z0-9=]*?d=(?<serial>.+) /",$res,$serial);
                            $serial=$serial['serial'];
                            $apiUrl='https://berocloud.beronet.com/index.php?r=api/register';
                            $ch = curl_init();  

                            $data = array('serial'=>$serial, 'cloud_username'=>$_POST['cloud_username'], 'cloud_password'=>$_POST['cloud_password']);

                            curl_setopt($ch, CURLOPT_URL, $apiUrl);
                            curl_setopt($ch, CURLOPT_POST, 1);
                            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

                            $result = curl_exec($ch);
                            preg_match("/[^a-zA-Z0-9=]*?yaqwsx(?<key>.+)yaqwsx/",$result,$key);
                            $key=unserialize($key['key']);
                            if (isset($key['key'])){
    				$bc = new beroConf('root');
				$bc->set('root','cloud_key',$key['key']);
				$query=$ba->select("select option from activate");
				while($entry = $ba->fetch_array($query)){

                                    if ($entry['option'] <= 1){
                                        $query =  $ba->update("UPDATE activate SET option=1");
                                        $table.= "<script>aktivieren(1,'remoteM','1','".ACTIVATE."');</script>";
                                    }
				}
				$result=preg_replace("/[^a-zA-Z0-9=]*?yaqwsx(?<key>.+)yaqwsx/",". ",$result);
                            }
                            curl_close($ch);
                        }
		}

		require_once("./includes/lang.php");
		if ($result!="")  $table.="<div class='center'><font color='red'>".$result."</font><br/></div>";
		$table .= "
                    <script>
                    $(document).ready(function() {
                        snmp_show();
                    });
                    function snmp_show(){
                    if( $('#snmp_enable').attr('checked')){
                        $('#traps').show();
                        $('#sink').show();
                        $('#interval').show();
                    }else{
                        $('#traps').hide();
                        $('#sink').hide();
                        $('#interval').hide();
                    }
                    }
                    </script>
                    <form class='extensions_form' action='' method='POST' autocomplete='off'>
					<input type=hidden name=m value=" . $_GET['m'] . ">
					<table class='contenttoc'>
					<tr>
					<th colspan='2'>".CLOUD_TABLE_HEADER_DIS."</th>
					</tr>
					<tr>
					<td><b>Cloud Username:</b></td>
					<!--<td><input type='text' name='register_key'></td>-->
					<td><input type='text' name='cloud_username'></td>
					</tr>
					<tr>
					<td><b>Cloud password:</b></td>
					<td><input type='password' name='cloud_password'></td>
					</tr>
					<tr>
					<td colspan='2' onmouseover=\"Tip('".CLOUD_NETWORK_HINT."')\" onmouseout='UnTip()'><input name='submit' type='submit' value='".BUTTON_REGISTER."'>
					</td>
					</tr>
					</table>
					</form>
					<br/>

					<form class='extensions_form' name='cloud' action='' method='POST'>
					<table class='contenttoc' id='table'>
					<tr>
					<td><b>".CLOUD_ENABLE_DIS.":</b></td>
					<td>" . $this->cloud_enable() . "</td>
					</tr>";
		if ($_SESSION['beroari_username']=="beroAdmin")
			$table.="<tr>
					<td><b>".CLOUD_KEY_DIS.":</b></td>
					<td><input type='text' name='cloud_key' value='" . $this->cloud_key() . "'></td>
					</tr>";

                        $table.="<tr>
					<td colspan='2'><input name='submit' type='submit' value='".BUTTON_SAVE."'>
					</td>
					</tr>
					</table>
					</form>
					<br/>
                                        <form class='extensions_form' name='proxy' action='' method='POST' onsubmit='if (proxyEnabled[1].checked==true) return (is_not_empty(proxyPort.value,\"Proxy port\") && is_not_empty(proxyAddress.value,\"Proxy address\") && verify_number(proxyPort.value,\"Proxy port\") && check_port(proxyPort.value,\"Proxy port\")); else return true;'>
					<table class='contenttoc' id='table'>
                                        <tr>
					<th colspan='2'>".CLOUD_PROXY_SETTINGS."</th>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_ENABLE.":</b></td>
					<td>".$this->proxy_enable()."</td>
					</tr>
					<tr>
					<td><b>".CLOUD_PROXY_ADDRESS.":</b></td>
					<td><input type='text' name='proxyAddress' value='".$ba->get('proxyAddress')."'></td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_PORT.":</b></td>
					<td><input type='text' name='proxyPort' value='".$ba->get('proxyPort')."'></td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_TYPE.":</b></td>
					<td>".$this->proxy_type()."</td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_USER.":</b></td>
					<td><input type='text' name='proxyUser' value='".$ba->get('proxyUser')."'></td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_SECRET.":</b></td>
					<td><input type='text' name='proxySecret' value='".$ba->get('proxySecret')."'></td>
					</tr>
                                        <tr>
					<td colspan='2'><input name='submit' type='submit' value='".BUTTON_SAVE."'>
					</td>
					</tr>
					</table>
					</form>
					<br/>
					<form class='extensions_form' action='' method='POST' onsubmit='if (snmp_enabled[1].checked==true) return (verify_number(snmptraps_intervall.value,\"SNMP-Traps interval\")); else return true;'>
					<input type=hidden name=m value=" . $_GET['m'] . ">
					<table class='contenttoc'>
					<tr>
					<th colspan='2'>".SNMP_TABLE_HEADER_DIS."</th>
					</tr>
					<tr>
					<td><b>".SNMP_ENABLED_DIS.":</b></td>
					<td>" . $this->snmp_enabled() . "</td>
					</tr>
                                        <tr id='traps'>
					<td><b>".SNMP_TRAPS_DIS.":</b></td>
					<td>" . $this->snmptraps() . "</td>
					</tr>
                                        <tr id='sink'>
					<td><b>".SNMP_TRAPS_SINK_DIS.":</b></td>
					<td>" . $this->snmptraps_sink() . "</td>
					</tr>
                                        <tr id='interval'>
					<td><b>".SNMP_TRAPS_INTERVALL_DIS.":</b></td>
					<td>" . $this->snmptraps_intervall() . "</td>
					</tr>
					<tr>
					<td colspan='2'><input name='submit' type='submit' value='".BUTTON_SAVE."'>
					</td>
					</tr>";
					if (is_file("/usr/local/conf/BEROFIX-MIB.txt"))
					$table .="<tr>
					<td colspan='2'><a href=\"misc/files_download.php?option=BEROFIX-MIB\">Download BEROFIX-MIB</a></td>
					</tr>";
					$table .= "</table>
					</form>";
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
		return $table;
	}

}
?>
